SystemOrganization addCategory: #TPDBZ!

Object subclass: #Guerrero
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:54'!
aliarseCon: unGuerrero
(self puedeAliarseCon: unGuerrero) ifTrue:[ self concretarAlianzaCon: unGuerrero ] ifFalse: [ self error: 'Imposible realizar la alianza pedida' ].! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:37'!
esBueno
^tipo esBueno.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:33'!
esDebil 
^(nivelDePelea<15000)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:51'!
esMasGrosoQue: unGuerrero
^((self nivelDePelea + self nivelesDePeleaAliados)> unGuerrero nivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:49'!
nivelesDePeleaAliados
self aliados collect:[ :unAliado | unAliado nivelDePelea] sum.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 16:58'!
puedeAliarseCon: unGuerrero 
^(unGuerrero aceptaA: self) & (self aceptaA: unGuerrero)! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo
	^ tipo! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo: anObject
	tipo := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

Guerrero subclass: #Monstruo
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 16:57'!
aceptaA: unGuerrero 
^true.! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 17:00'!
aceptaA: unGuerrero
^(unGuerrero esMasGrosoQue: self not)! !

Guerrero subclass: #Terricola
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:58'!
aceptaA: unGuerrero
^(unGuerrero esBueno & (self meEntra: unGuerrero))! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 18:09'!
aliadosDebiles
^self aliados select: [ :unAliado | unAliado esDebil] ! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
cantAliadosDebiles
^self aliadosDebiles size! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
meEntra: unGuerrero
^(unGuerrero esDebil & (self cantAliadosDebiles >5)) not! !

Object subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

Object subclass: #TipoBueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^true! !

Object subclass: #TipoMalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^false! !
